package demux.ty;

import java.nio.ByteBuffer;

import common.Util;


public class RecordHeader {
	public static final int VIDEO_DATA=0xE0;
	public static final int AUDIO_DATA=0xC0;
	public static final int CLOSED_CAPTION_DATA=0x01;
	public static final int EXTENDED_DATA=0x02;
	
	public byte type;
	public byte typeNibble;
	public long timestamp;
	
	public int recordSize;
	int streamBufferId;
	int streamBufferOffset;
	
	int extendedData;
	//int offset;
	
	public int parse(ByteBuffer chunk, int offset) {
		//this.offset=offset;
		//if ((packet[offset]&0x01)!=1) {
			//ty_record_size 19 bits
			//recordSize = ((packet[offset]&0xfe) >>1) + ((packet[offset + 1]&0xFF) << 7) + (packet[offset + 2]&0x0F) << 15;
			recordSize= ((((chunk.get(offset)&0xFF)<<8) + (chunk.get(offset+1)&0xFF))<<4) + ((chunk.get(offset+2)&0xFF)>>4);
			//recordSize =((packet[offset]&0xFF)<<12) + ((packet[offset+1]&0xFF)<<4) + ((packet[offset+2]&0xF0)>>4);
			streamBufferId=(chunk.get(offset + 4)&0xFF) + (chunk.get(offset + 5)&0x0F) <<8;
			streamBufferOffset=((chunk.get(offset + 5)&0xF0) >> 4) + ((chunk.get(offset + 6)&0xFF) << 4) + (chunk.get(offset + 7)&0xFF) << 12;
			
		/*} else {
			recordSize=0;
			extendedData=(packet[offset]&0xf0) >> 4 + (packet[offset+1]&0xFF) <<4;
		}*/
		type = chunk.get(offset + 3);
		typeNibble = (byte)(chunk.get(offset+2)&0x0f);
		
		timestamp=Util.getLong(chunk, offset+8, 8, false);
		return 16;
	}
	public int parse(final byte chunk[], final int offset) {
		//if ((packet[offset]&0x01)!=1) {
			//ty_record_size 19 bits
			recordSize= ((((chunk[offset]&0xFF)<<8) + (chunk[offset+1]&0xFF))<<4) + ((chunk[offset+2]&0xFF)>>4);
			streamBufferId=(chunk[offset+4]&0xFF) + (chunk[offset+5]&0x0F) <<8;
			streamBufferOffset=((chunk[offset+5]&0xF0) >> 4) + ((chunk[offset+6]&0xFF) << 4) + (chunk[offset+7]&0xFF) << 12;
			
		type = chunk[offset+3];
		typeNibble = (byte)(chunk[offset+2]&0x0f);
		
		timestamp=Util.getLong(chunk, offset+8, 8, false);
		return 16;
	}
	
}
