package muxer.filter;

import java.io.IOException;

import muxer.MuxFilter;
import muxer.MuxManager;


import common.packet.Packet;

import demux.Demuxer;

public class PacketRecyclerMuxFilter extends MuxFilter {
	private Demuxer demuxer;
	
	public PacketRecyclerMuxFilter(Demuxer demuxer) {
		
	}
	
	public final boolean handlesRaw(int container) {
		return true;
	}

	public int addPacket(Packet packet) throws IOException {
		demuxer.returnToCache(packet);
		return MuxManager.CONTINUE;
	}
	public int getPosition() {
		return POSITION_POST_MUXER;
	}
}
